#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "structs.h"


void list_remove(t_list *x) {
	x->prev->next = x->next;
	x->next->prev = x->prev;
    free(x);
}

t_list * list_learch(t_list *head, int k) {
	t_list *x = head->next;
	while (x != head && x->elemento != k) 
		x = x->next;
	return x==head?NULL:x;
}
void list_add (t_list *pn, char *data) {
    t_list *x = calloc(1, sizeof(t_list));
    strcpy(x->data, data);    
    /* inserta delante de nodo apuntado por pn*/
	x->next = pn->next;
	pn->next->prev = x;
	pn->next = x;
	x->prev = pn;
}

char *list_get(t_list *x, int index) {
    while (index--) {
        x = x->next;
    }
    return x->next->data;
}

void list_new(t_list **list) {
    *list = calloc(1, sizeof(t_list));
    (*list)->next = *list;
    (*list)->prev = *list;
}

void list_free(t_list *list) {
    while (list != list->next)
        list_remove(list->next);
    free(list);
}

void stack_new(t_stack **stack) {
    list_new(stack);
}



void stack_push(t_stack *stack, char* data) {
    list_add(stack, data);
}

void stack_get(t_stack *stack, char* data) {
    strcpy(data, stack->next->data);
}

void stack_pop(t_stack *stack, char *data) {
	if (stack->next == NULL)
		return ;
    strcpy(data, stack->next->data);
    list_remove(stack->next);
}

void stack_free(t_stack *stack) {
    list_free(stack);
}
